#property library   
 
#import "AG_Lib.ex4"
   int AG_Message(string& Message[], string _Text);//     Message[]
#import

bool FiboShow, MarketExecution;
int sdPeriod, sdPrice, sdMAMethod;
int MagicNumber = 100001;
double volStop, perTakeProfit;
color FiboColor = Yellow;

int TicketPos, TypePos,
    Signal,                                        //   
    LastOver,
    ME_Ticket;                                     //  ,  ..
                                                   // .. -  
                                                   // .. MarketExecution
bool Activate, FreeMarginAlert, FatalError, FirstRun = True,
     ME_Activate;                                  //    ..
                                                   // .. -  
                                                   // .. 
double Tick, Spread, StopLevel, MinLot, MaxLot, LotStep, Lots,
       TPfactor,                                   //  perTakeProfit 
                                                   // ..   
       TP,                                         //   
       SL,                                         //   
       ME_SL,                                      //   -..
                                                   // .. MarketExecution
       ME_TP;                                      //   ..
                                                   // .. MarketExecution
datetime LastBar,                                  //   ,  ..
                                                   // ..     ..
                                                   // .. 
         LastSignal;                               //   ,  ..
                                                   // ..   ..
                                                   // ..


string OpenOrderSound = "ok.wav";
string prefix = "DETR_";

int AG_DefyingTrend(int Parol_S, double Order[][], string Object[],
                             double Instrument[][][][], int Ddraw_Object[][], 
                             double& Tuning[],double& Manager[][],string& Message[])
{    
   if (FirstRun)
      if (!_init(Message, Instrument))
         return(0);

// - 1 -  ==    ? ===========================================
   if (FatalError)                                 //  ,  .. 
      return(0);                                   // ..  
// - 1 -  ==   ============================================================

// - 2 -  ==    -   ====================
   if (ME_Activate)                                //    
      if (!ModifyPosition())                       //  
         return(1);
// - 2 -  ==   ============================================================

// - 3 - ==     ===============================================
   if (LastBar == Time[0])                         //      ..
      return(1);                                   // ..  ,
                                                   // ..   ..
                                                   // .. 
// - 3 - ==   =============================================================

// - 4 - ==      ===================================
   if (!IsTesting())
   {
      Tick = MarketInfo(Symbol(), MODE_TICKSIZE);  //    
      Spread = ND(MarketInfo(Symbol(), MODE_SPREAD)*Point);//  
      StopLevel = ND(MarketInfo(Symbol(), MODE_STOPLEVEL)*Point);//  
   } 
   Lots = NormalizeDouble(Tuning[1], 2);           //   
// - 4 - ==   =============================================================

// - 5 - ==     ===========================================
   if (LastSignal != Time[0])                      //      ..
   {                                               // ..  
      GetSignal();                                 //   
      LastSignal = Time[0];                        //    .. 
   }                                               // ..   
// - 5 - ==   =============================================================
   
// - 6 - ==    ================================================
   FindOrders();                                   //   
   if (Signal != 0)                                //    
      if (!Trade(Message))                         //    
         return(1);                                
// - 6 - ==   =============================================================

   LastBar = Time[0];

   return(1);
}

//+-------------------------------------------------------------------------------------+
//|                                              |
//+-------------------------------------------------------------------------------------+
double LotRound(double L)
{
 return(MathRound(MathMin(MathMax(L, MinLot), MaxLot)/LotStep)*LotStep);
}

//+-------------------------------------------------------------------------------------+
//|                                                   |
//+-------------------------------------------------------------------------------------+
bool _init(string& Message[], double Instrument[][][][])
{
 AG_Message(Message, "  '' ''");
// - 1 - ==    ================================================
 sdPeriod = NormalizeDouble(Instrument[0][0][1][0], 0); //  StdDev - AT_1
 sdPrice = NormalizeDouble(Instrument[0][0][2][0], 0);  //    StdDev - AT_2
 sdMAMethod = NormalizeDouble(Instrument[0][0][3][0], 0);//    - AT_3
 volStop = NormalizeDouble(Instrument[0][0][4][0], 1);  //     ..
                                                        // ..  - AT_4
 perTakeProfit = NormalizeDouble(Instrument[0][0][5][0], 1); //    
                                                        // ..   - AT_5
 FiboShow = NormalizeDouble(Instrument[0][0][6][0], 0); //    - AT_6
 MarketExecution = NormalizeDouble(Instrument[0,0,6,0], 0);//   - AT_7
// - 1 - ==   =============================================================

// - 2 - ==     ====================================
   if (sdPeriod < 1)
   {
      AG_Message(Message, "    StdDev (AT_1). ");
      AG_Message(Message, "  25.");
      sdPeriod = 25;
   }
   if (sdPrice < 0 || sdPrice > 6)
   {
      AG_Message(Message, "    StdDev (AT_2). ");
      AG_Message(Message, "  0.");
      sdPrice = 0;
   }
   if (sdMAMethod < 0 || sdMAMethod > 3)
   {
      AG_Message(Message, "     StdDev (AT_3). ");
      AG_Message(Message, "  0.");
      sdMAMethod = 0;
   }
   if (volStop < 0)
   {
      AG_Message(Message, "     (AT_4). ");
      AG_Message(Message, "  2.");
      volStop = 2;
   }
   if (perTakeProfit < 10)
   {
      AG_Message(Message, "     (AT_5). ");
      AG_Message(Message, "  310.");
      perTakeProfit = 310;
   }
   if (FiboShow < 0)
   {
      AG_Message(Message, "     (AT_6)  0  1.");
      AG_Message(Message, " !");
      return(false);
   }
   if (MarketExecution < 0)
   {
      AG_Message(Message, "  (AT_7)   0 (.)  1 (.).");
      AG_Message(Message, " !");
      return(false);
   }
// - 2 - ===========================   ====================================
  
// - 3 - ======================      ====================
   Tick = MarketInfo(Symbol(), MODE_TICKSIZE);                         //      
   MinLot = MarketInfo(Symbol(), MODE_MINLOT);    //    
   MaxLot = MarketInfo(Symbol(), MODE_MAXLOT);   //    
   LotStep = MarketInfo(Symbol(), MODE_LOTSTEP);          //    
   Spread = ND(MarketInfo(Symbol(), MODE_SPREAD)*Point);                 //  
   StopLevel = ND(MarketInfo(Symbol(), MODE_STOPLEVEL)*Point);  //   
// - 3 - ===========================   ====================================

// - 4 - ========================    =========================
   TPfactor = perTakeProfit/100;
   LastBar = 0;
   ME_Activate = False;
   FirstRun = False;
// - 4 - ===========================   ====================================

   return(True);
}

//+-------------------------------------------------------------------------------------+
//|   .   ,   True,  - False    |
//+-------------------------------------------------------------------------------------+  
bool WaitForTradeContext()
{
 int P = 0;
 //  ""
 while(IsTradeContextBusy() && P < 5)
   {
    P++;
    Sleep(1000);
   }
 // -------------  
 if(P == 5)
   return(False);
 return(True);    
}
 
//+-------------------------------------------------------------------------------------+
//|                                              |
//+-------------------------------------------------------------------------------------+
double ND(double A)
{
 return(NormalizeDouble(A, Digits));
}  

//+-------------------------------------------------------------------------------------+
//|                                                |
//+-------------------------------------------------------------------------------------+
double NP(double A)
{
 return(MathRound(A/Tick)*Tick);
}  

//+-------------------------------------------------------------------------------------+
//|                                                         |
//+-------------------------------------------------------------------------------------+
string ErrorToString(int Error)
{
 switch(Error)
   {
    case 2: return("  ,   ."); 
    case 5: return("    ,  ."); 
    case 6: return("   ,   ."); 
    case 64: return(" ,   .");
    case 132: return(" ."); 
    case 133: return(" ."); 
    case 149: return(" ."); 
   }
}
  
//+-------------------------------------------------------------------------------------+
//| ""                                                         |
//|    OpenOrder            |
//| :                                                                         |
//|   0 -                                                                      |
//|   1 -                                                                 |
//|   2 -   Price                                                         |
//|   3 -   SL                                                            |
//|   4 -   TP                                                            |
//|   5 -   Lot                                                           |
//+-------------------------------------------------------------------------------------+
int OpenOrderCorrect(string& Message[], int Type, double Price, double SL, 
                     double TP, bool Redefinition = True)
// Redefinition -  True     
//                 False -  
{
// - 2 - ==     ====================================
   if (AccountFreeMarginCheck(Symbol(), OP_BUY, Lots) <= 0 || GetLastError() == 134) 
   {
      if (!FreeMarginAlert)
      {
         AG_Message(Message, "    .");
         AG_Message(Message, "Free Margin = "+DoubleToStr(AccountFreeMargin(), 2));
         FreeMarginAlert = True;
      } 
      return(5);  
   }
   FreeMarginAlert = False;  
// - 2 - ==   =============================================================

// - 3 - ==   Price, SL  TP    ====================   
   RefreshRates();
   switch (Type)
   {
      case OP_BUY: 
                  string S = "BUY"; 
                  if (MathAbs(Price-Ask)/Point > 3)
                    if (Redefinition) Price = NP(Ask);
                    else              return(2);
                  if (NP(TP-Bid) < StopLevel && TP != 0)
                    if (Redefinition) TP = NP(Bid+StopLevel);
                    else              return(4);
                  if (NP(Bid-SL) < StopLevel)
                    if (Redefinition) SL = NP(Bid-StopLevel);
                    else              return(3);
                  break;
      case OP_SELL: 
                   S = "SELL"; 
                   if (MathAbs(Price-Bid)/Point > 3)
                     if (Redefinition) Price = NP(Bid);
                     else              return(2);
                   if (NP(Ask-TP) < StopLevel) 
                     if (Redefinition) TP = NP(Ask-StopLevel);
                     else              return(4);
                   if (NP(SL-Ask) < StopLevel && SL != 0)
                     if (Redefinition) SL = NP(Ask+StopLevel);
                     else              return(3);
                   break;
      case OP_BUYSTOP: 
                      S = "BUYSTOP";
                      if (NP(Price-Ask) < StopLevel)
                        if (Redefinition) Price = NP(Ask+StopLevel);
                        else              return(2);
                      if (NP(TP-Price) < StopLevel && TP != 0)
                        if (Redefinition) TP = NP(Price+StopLevel);
                        else              return(4);
                      if (NP(Price-SL) < StopLevel)
                        if (Redefinition) SL = NP(Price-StopLevel);
                        else              return(3);
                      break;
      case OP_SELLSTOP: 
                       S = "SELLSTOP";
                       if (NP(Bid-Price) < StopLevel)
                         if (Redefinition) Price = NP(Bid-StopLevel);
                         else              return(2);
                       if (NP(Price-TP) < StopLevel)
                         if (Redefinition) TP = NP(Price-StopLevel);
                         else              return(4);
                       if (NP(SL-Price) < StopLevel && SL != 0)
                         if (Redefinition) SL = NP(Price+StopLevel);
                         else              return(3);
                       break;
      case OP_BUYLIMIT: 
                       S = "BUYLIMIT";
                       if (NP(Ask-Price) < StopLevel)
                        if (Redefinition) Price = NP(Ask-StopLevel);
                        else              return(2);
                       if (NP(TP-Price) < StopLevel && TP != 0)
                         if (Redefinition) TP = NP(Price+StopLevel);
                         else              return(4);
                       if (NP(Price-SL) < StopLevel)
                         if (Redefinition) SL = NP(Price-StopLevel);
                         else              return(3);
                       break;
      case OP_SELLLIMIT: 
                       S = "SELLLIMIT";
                       if (NP(Price - Bid) < StopLevel) 
                         if (Redefinition) Price = NP(Bid+StopLevel);
                         else              return(2);
                       if (NP(Price-TP) < StopLevel)
                         if (Redefinition) TP = NP(Price-StopLevel);
                         else              return(4);
                       if (NP(SL-Price) < StopLevel && SL != 0)
                         if (Redefinition) SL = NP(Price+StopLevel);
                         else              return(3);
                       break;
   }
// - 3 - ==   =============================================================
 
// - 4 - ==     ==========================================
   Print("MarketExecution = ", MarketExecution);
   if (MarketExecution)                            //    ..
      if (Type < 2)                                // ..MarketExecution,   ..
      {                                            // ..    ..
                                                   // .. 
         ME_SL = SL;                               //   -
         ME_TP = TP;                               //   
         SL = 0;                                   // -   0
         TP = 0;                                   //    0
      }
   Print("ME_SL = ", ME_SL, ", ME_TP = ", ME_TP);
// - 4 - ==   =============================================================
 
// - 5 - ==       =================================
   if(WaitForTradeContext())                       //   ..
   {                                               // ..
      AG_Message(Message, "     "+S+" ...");  
      int ticket = OrderSend(Symbol(), Type, Lots, //  
                             Price, 3, SL, TP, "AG_AT", MagicNumber, 0);
      // - 5.1 - ==    ==========================================
      if(ticket < 0)                               //   ..
      {                                            // .. 
         int Error = GetLastError();
         if (Error == 2 || Error == 5 || Error == 6 || Error == 64 
            || Error == 132 || Error == 133 || Error == 149)//   
         {
            AG_Message(Message, "     . . ");
            AG_Message(Message, ErrorToString(Error)+"  !");
            FatalError = True;
         }
         else 
            AG_Message(Message,                    //  
                       "   "+S+": "+Error); 
         return(1);
      }
      // - 5.1 - ==   =====================================================
    
      // - 5.2 - ==    ===========================================
      if (MarketExecution && Type < 2 &&           //    ..
          !(ME_SL == 0 && ME_TP == 0))             // ..MarketExecution  - 
      {                                            // ..   ,  ..
                                                   // ..   .. 
         ME_Ticket = ticket;                       // .. ,..
         ME_Activate = True;                       // ..  
                                                   // .. -  
                                                   // ..
      }
      Print("ME_Ticket = ", ME_Ticket, ", ME_Activate = ", ME_Activate);
      AG_Message(Message, " "+S+"  !"); 
      return(0); 
      // - 5.2 - ==   =====================================================
   }
   else
   {
      AG_Message(Message, "     !");
      return(1);  
   } 
// - 5 - ==   =============================================================
}
//+-------------------------------------------------------------------------------------+
//|                                     |
//+-------------------------------------------------------------------------------------+
double RegressionSlope(int bar1, int bar2)
{
// - 1 - ==   ====================================================
   int N = bar2 - bar1 + 1;                        //    
   if (N <= 0) return(0);                          //     ..
                                                   // .. ,   
   double sumy = 0,                                //   
          sumx = 0.0,                              //   
          sumxy = 0.0,                             //    ..
                                                   // ..
          sumx2 = 0.0;                             //    
// - 1 - ==   =============================================================

// - 2 - ==    =================================================
   for (int i = bar1; i <= bar2; i++)              //   bar1     bar2
   {
      sumy += Close[i];                            //   
      sumxy += Close[i]*i;                         //    ..
                                                   // .. 
      sumx += i;                                   //  
      sumx2 += i*i;                                //   
   }  
// - 2 - ==   =============================================================
 
// - 3 - ==    ===================================================
   double c = sumx2*N - sumx*sumx;                 //   ..
                                                   // .. k
   if (c == 0.0) return(0);                        //     ..
                                                   // ..
   return((sumxy*N - sumx*sumy)/c);                //    K
// - 3 - ==   =============================================================
}             
//+-------------------------------------------------------------------------------------+
//|                                 |
//+-------------------------------------------------------------------------------------+
void ShowFibo(datetime time1, double price1, datetime time2, double price2)
{
   string name = prefix + "SignalFibo";            //   
   if (ObjectFind(name) < 0)                       //     , ..
   {
      ObjectCreate(name, OBJ_FIBO, 0, time1, price1, time2, price2);// .. 
      ObjectSet(name, OBJPROP_COLOR, FiboColor);   //    
      ObjectSet(name, OBJPROP_FIBOLEVELS, 3);      // ,   ..
                                                   // ..  3
      ObjectSet(name, OBJPROP_FIRSTLEVEL, 0);      //   -  0
      ObjectSet(name, OBJPROP_FIRSTLEVEL+1, 1);    //   -  100%
      ObjectSet(name, OBJPROP_FIRSTLEVEL+2, TPfactor);//   - ..
                                                   // ..
      ObjectSetFiboDescription(name, 0, "0.0 (%$)");//   
      ObjectSetFiboDescription(name, 1, "100.0 (%$)");
      ObjectSetFiboDescription(name, 2, DoubleToStr(perTakeProfit, 1) + " (%$)");
   }
   else                                            //   , ..
   {
      ObjectMove(name, 0, time1, price1);          // ..    ..
      ObjectMove(name, 1, time2, price2);          // .. 
   }
}

//+-------------------------------------------------------------------------------------+
//|                                                      |
//+-------------------------------------------------------------------------------------+
void GetSignal()
{
// - 1 - ==      =========================
   Signal = 0;                                     //     
   int ExtBar = 3;                                 //  ,  ..
                                                   // ..  ..
                                                   // ..StdDev
   double STD1 = ND(iStdDev(NULL, 0, sdPeriod, 0,  //  StdDev   
                         sdMAMethod, sdPrice, 1));
   double STD2 = ND(iStdDev(NULL, 0, sdPeriod, 0,  //  StdDev  ..
                         sdMAMethod, sdPrice, 2)); // ..
   double STD3 = ND(iStdDev(NULL, 0, sdPeriod, 0,  //  StdDev ..
                         sdMAMethod, sdPrice, 3)); // ..  
// - 1 - ==   =============================================================

   if (!(STD1 < STD2 && STD2 > STD3)) return;      //     ..
                                                   // ..StdDev,    

// - 2 - ==    Standart Deviation ==================================
   double STDn = ND(iStdDev(NULL, 0, sdPeriod, 0,  //  StdDev  , ..
                         sdMAMethod, sdPrice, 4));  // ..   
   while (STDn < STD3 && ExtBar < Bars)            //   StdDev  ..
   {                                               // ..    ..
      ExtBar++;                                    // ..  
      STD3 = STDn;                                 //    ..
                                                   // ..
      STDn = ND(iStdDev(NULL, 0, sdPeriod, 0,      //    StdDev
                     sdMAMethod, sdPrice, ExtBar+1));
   }
// - 2 - ==   =============================================================

   if (ExtBar == Bars) return;                     //   ,  
                                                   // .. 
// - 3 - ==        ==========================
   double slope = RegressionSlope(1, ExtBar);      //     
   if (slope > 0)                                  //     (
   {                                               // ..   ..
      Signal = 1;                                  // ..),   ..
                                                   // ..
      double min = Low[iLowest(NULL, 0, MODE_LOW,  //    
                       ExtBar, 1)];
      double max = High[iHighest(NULL, 0, MODE_HIGH, ExtBar, 1)];//  
      SL = NP(min - volStop*iATR(NULL, 0, 24, 1)); //  -  
      TP = NP(min + TPfactor*(max - min));         //   , ..
                                                   // ..
      if (FiboShow)                                //     ,..
         ShowFibo(Time[ExtBar], max, Time[1], min);// ..  
   }
   if (slope < 0)                                  //     (
   {                                               // ..   ..
      Signal = -1;                                 // ..),   ..
                                                   // ..
      max = High[iHighest(NULL, 0, MODE_HIGH, ExtBar, 1)];//   ..
                                                   // ..
      min = Low[iLowest(NULL, 0, MODE_LOW, ExtBar, 1)];//   
      SL = NP(max + volStop*iATR(NULL, 0, 24, 1) + Spread);//  -  
      TP = NP(max - TPfactor*(max - min) + Spread);//  -  , ..
                                                   // ..
      if (FiboShow)                                //     ,..
         ShowFibo(Time[ExtBar], min, Time[1], max);// ..  
   }
// - 3 - ==   =============================================================
}

//+-------------------------------------------------------------------------------------+
//|                                                            |
//+-------------------------------------------------------------------------------------+
void FindOrders()
{
// - 1 - ==     ======================================
   int total = OrdersTotal() - 1;
   TicketPos = -1;                                 //  
   TypePos = -1;                                   //  
// - 1 - ==   =============================================================
 
// - 2 - ==   ================================================================
   for (int i = total; i >= 0; i--)                //    
      if (OrderSelect(i, SELECT_BY_POS))           // ,   
         if (OrderMagicNumber() == MagicNumber &&  //   , ..
             OrderSymbol() == Symbol())            // ..   
         {                                         //    ..
            TicketPos = OrderTicket();             // .. 
            TypePos = OrderType();
         }
// - 2 - ==   =============================================================
}
//+-------------------------------------------------------------------------------------+
//|                                                     |
//+-------------------------------------------------------------------------------------+
bool CloseDeal(int ticket) 
{                          
   if (OrderSelect(ticket, SELECT_BY_TICKET) &&    //    .. 
       OrderCloseTime() == 0)                      // ..    
      if (WaitForTradeContext())                   //    ?
      {
         if (OrderType() == OP_BUY)                //    .. 
            double Price = MarketInfo(Symbol(), MODE_BID);// ..,  ..
                                                   // .. BID
         else                                      //    .. 
            Price = MarketInfo(Symbol(), MODE_ASK);// ..,    ASK
         if (!OrderClose(OrderTicket(), OrderLots(), NP(Price), 3))//   ..
            return(False);                         // .. ,  ..
                                                   //  - False
      }    
      else
         return(false);
   return(True);                                   //    
}  
//+-------------------------------------------------------------------------------------+
//|                                                                      |
//+-------------------------------------------------------------------------------------+
bool Trade(string &Message[])
{
// - 1 - ==     ==============================================
   if (Signal > 0 && TypePos != OP_BUY)            //  ,   ..
   {                                               // .. 
      if (TypePos == OP_SELL)                      //     
         if (!CloseDeal(TicketPos))                // .. .   ..
            return(false);                         // ..
      RefreshRates();                              //    Bid  Ask ..
      if (TP - Ask > StopLevel)                    // ..   , 
         if (OpenOrderCorrect(Message, OP_BUY,     // ..   
                              NP(Ask), SL, TP) != 0)
            return(false);
   }
// - 1 - ==   =============================================================

// - 2 - ==     =============================================
   if (Signal < 0 && TypePos != OP_SELL)           //  ,   ..
   {                                               // .. 
      if (TypePos == OP_BUY)                       //     
         if (!CloseDeal(TicketPos))                // .. .   ..
            return(false);                         // ..
      RefreshRates();                              //    Bid  Ask ..
      if (Bid - TP > StopLevel)                    // ..   , 
         if (OpenOrderCorrect(Message, OP_SELL,    // ..   
                               NP(Bid), SL, TP) != 0)
            return(false);
   }
// - 2 - ==   =============================================================
   return(True);                                   //    
}
//+-------------------------------------------------------------------------------------+
//|   -      MarketExecution        |
//+-------------------------------------------------------------------------------------+
bool ModifyPosition()
{
   if (OrderSelect(ME_Ticket, SELECT_BY_TICKET)    //     ..
       && OrderCloseTime() == 0)                   // ..   
      if (WaitForTradeContext())                   //   ..
      {                                            // ..
         RefreshRates();                           //   Bid  Ask
         if (OrderType() == OP_BUY)                //   ..
         {                                         // ..   
            if (ME_TP - Bid <= StopLevel)          //    , ..
               ME_TP = Bid + StopLevel + Tick;     // ..  
            if (Bid - ME_SL <= StopLevel)          //    , ..
               ME_SL = Bid - StopLevel - Tick;     // ..  
         }
         else                                      //   ..
         {                                         // ..   
            if (Ask - ME_TP <= StopLevel)          //    , ..
               ME_TP = Ask - StopLevel - Tick;     // ..  
            if (ME_SL - Ask <= StopLevel)          //    , ..
               ME_SL = Ask + StopLevel + Tick;     // ..  
         }
         if (!OrderModify(ME_Ticket, 0, NP(ME_SL), //  .   
                          NP(ME_TP), 0))
            return(false);                         // ..false
      }
      else                                         //    
         return(false);
         
   ME_Activate = false;                            //  
   return(true);                                   //    
}